diff -r f6ef988fda71 trytond/ir/property.py
--- a/trytond/ir/property.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/property.py	Sun Sep 23 17:30:03 2012 +0200
@@ -6,37 +6,42 @@
 from ..cache import Cache
 from ..pool import Pool
 
+__all__ = [
+    'Property',
+    ]
+
 
 class Property(ModelSQL, ModelView):
     "Property"
-    _name = 'ir.property'
-    _description = __doc__
+    __name__ = 'ir.property'
     _rec_name = 'field'
     value = fields.Reference('Value', selection='models_get')
     res = fields.Reference('Resource', selection='models_get', select=True)
     field = fields.Many2One('ir.model.field', 'Field',
         ondelete='CASCADE', required=True, select=True)
+    _models_get_cache = Cache('ir_property.models_get', context=False)
 
-    @Cache('ir_property.models_get')
-    def models_get(self):
+    @classmethod
+    def models_get(cls):
+        models = cls._models_get_cache.get(None)
+        if models:
+            return models
         cursor = Transaction().cursor
         cursor.execute('SELECT model, name FROM ir_model ORDER BY name ASC')
-        res = cursor.fetchall() + [('', '')]
-        return res
+        models = cursor.fetchall() + [('', '')]
+        cls._models_get_cache.set(None, models)
+        return models
 
-    def get(self, names, model, res_ids=None):
+    @classmethod
+    def get(cls, names, model, res_ids=None):
         """
-        Return property value for each res_ids
-        :param names: property name or a list of property names
-        :param model: object name
-        :param res_ids: a list of record ids
-        :return: a dictionary
+        Return named property values for each res_ids of model
         """
         pool = Pool()
-        model_access_obj = pool.get('ir.model.access')
+        ModelAccess = pool.get('ir.model.access')
         res = {}
 
-        model_access_obj.check(model, 'read')
+        ModelAccess.check(model, 'read')
 
         names_list = True
         if not isinstance(names, list):
@@ -45,34 +50,29 @@
         if res_ids is None:
             res_ids = []
 
-        property_ids = self.search([
+        properties = cls.search([
             ('field.name', 'in', names),
             ['OR',
                 ('res', '=', None),
                 ('res', 'in', ['%s,%s' % (model, x) for x in res_ids]),
                 ],
             ], order=[])
-        properties = self.browse(property_ids)
 
         default_vals = dict((x, None) for x in names)
-        for property in (x for x in properties if not x.res):
-            value = property.value
+        for property_ in (x for x in properties if not x.res):
+            value = property_.value
             val = None
-            if value:
-                if value.split(',')[0]:
-                    try:
-                        val = int(value.split(',')[1]\
-                                .split(',')[0].strip('('))
-                    except ValueError:
-                        val = None
+            if value is not None:
+                if not isinstance(value, basestring):
+                    val = int(value)
                 else:
-                    if property.field.ttype == 'numeric':
+                    if property_.field.ttype == 'numeric':
                         val = Decimal(value.split(',')[1])
-                    elif property.field.ttype in ('char', 'selection'):
+                    elif property_.field.ttype in ('char', 'selection'):
                         val = value.split(',')[1]
                     else:
                         raise Exception('Not implemented')
-            default_vals[property.field.name] = val
+            default_vals[property_.field.name] = val
 
         if not res_ids:
             if not names_list:
@@ -82,80 +82,69 @@
         for name in names:
             res[name] = dict((x, default_vals[name]) for x in res_ids)
 
-        for property in (x for x in properties if x.res):
+        for property_ in (x for x in properties if x.res):
             val = None
-            if property.value:
-                if property.value.split(',')[0]:
-                    try:
-                        val = int(property.value.split(',')[1]\
-                                .split(',')[0].strip('('))
-                    except ValueError:
-                        val = None
+            if property_.value is not None:
+                if not isinstance(property_.value, basestring):
+                    val = int(property_.value)
                 else:
-                    if property.field.ttype == 'numeric':
-                        val = Decimal(property.value.split(',')[1])
-                    elif property.field.ttype in ('char', 'selection'):
-                        val = property.value.split(',')[1]
+                    if property_.field.ttype == 'numeric':
+                        val = Decimal(property_.value.split(',')[1])
+                    elif property_.field.ttype in ('char', 'selection'):
+                        val = property_.value.split(',')[1]
                     else:
                         raise Exception('Not implemented')
-            res[property.field.name][
-                int(property.res.split(',')[1].split(',')[0].strip('('))] = val
+            res[property_.field.name][int(property_.res)] = val
 
         if not names_list:
             return res[names[0]]
         return res
 
-    def _set_values(self, model, res_id, val, field_id):
+    @staticmethod
+    def _set_values(model, res_id, val, field_id):
         return {
             'value': val,
             'res': model + ',' + str(res_id),
             'field': field_id,
         }
 
-    def set(self, name, model, ids, val):
+    @classmethod
+    def set(cls, name, model, ids, val):
         """
-        Set property value for ids
-        :param name: property name
-        :param model: object name
-        :param ids: a list of ids
-        :param val: the value
-        :return: the id of the record created
+        Set named property value for ids of model
+        Return the id of the record created
         """
         pool = Pool()
-        model_field_obj = pool.get('ir.model.field')
-        model_access_obj = pool.get('ir.model.access')
+        ModelField = pool.get('ir.model.field')
+        ModelAccess = pool.get('ir.model.access')
 
-        model_access_obj.check(model, 'write')
+        ModelAccess.check(model, 'write')
 
-        field_id = model_field_obj.search([
+        model_field, = ModelField.search([
             ('name', '=', name),
             ('model.model', '=', model),
-            ], order=[], limit=1)[0]
-        model_obj = pool.get(model)
-        field = model_obj._columns[name]
+            ], order=[], limit=1)
+        Model = pool.get(model)
+        field = Model._fields[name]
 
-        property_ids = self.search([
-            ('field', '=', field_id),
+        properties = cls.search([
+            ('field', '=', model_field.id),
             ('res', 'in', [model + ',' + str(res_id) for res_id in ids]),
             ], order=[])
         with Transaction().set_user(0, set_context=True):
-            self.delete(property_ids)
+            cls.delete(properties)
 
-        default_id = self.search([
-            ('field', '=', field_id),
+        defaults = cls.search([
+            ('field', '=', model_field.id),
             ('res', '=', None),
             ], order=[], limit=1)
         default_val = None
-        if default_id:
-            value = self.browse(default_id[0]).value
+        if defaults:
+            value = cls(defaults[0].id).value
             default_val = None
-            if value:
-                if value.split(',')[0]:
-                    try:
-                        default_val = int(value.split(',')[1]\
-                                .split(',')[0].strip('('))
-                    except ValueError:
-                        default_val = None
+            if value is not None:
+                if not isinstance(value, basestring):
+                    default_val = int(value)
                 else:
                     if field._type == 'numeric':
                         default_val = Decimal(value.split(',')[1])
@@ -164,12 +153,8 @@
                     else:
                         raise Exception('Not implemented')
 
-        res = None
         if (val != default_val):
             for res_id in ids:
-                vals = self._set_values(model, res_id, val, field_id)
+                vals = cls._set_values(model, res_id, val, model_field.id)
                 with Transaction().set_user(0, set_context=True):
-                    res = self.create(vals)
-        return res
-
-Property()
+                    cls.create(vals).id
diff -r f6ef988fda71 trytond/ir/rule.py
--- a/trytond/ir/rule.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/rule.py	Sun Sep 23 17:30:03 2012 +0200
@@ -10,11 +10,14 @@
 from ..const import OPERATORS
 from ..pool import Pool
 
+__all__ = [
+    'RuleGroup', 'Rule',
+    ]
+
 
 class RuleGroup(ModelSQL, ModelView):
     "Rule group"
-    _name = 'ir.rule.group'
-    _description = __doc__
+    __name__ = 'ir.rule.group'
     name = fields.Char('Name', select=True)
     model = fields.Many2One('ir.model', 'Model', select=True,
             required=True)
@@ -34,60 +37,65 @@
     perm_create = fields.Boolean('Create Access')
     perm_delete = fields.Boolean('Delete Access')
 
-    def __init__(self):
-        super(RuleGroup, self).__init__()
-        self._order.insert(0, ('model', 'ASC'))
-        self._order.insert(1, ('global_p', 'ASC'))
-        self._order.insert(2, ('default_p', 'ASC'))
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(RuleGroup, cls).__setup__()
+        cls._order.insert(0, ('model', 'ASC'))
+        cls._order.insert(1, ('global_p', 'ASC'))
+        cls._order.insert(2, ('default_p', 'ASC'))
+        cls._sql_constraints += [
             ('global_default_exclusive', 'CHECK(NOT(global_p AND default_p))',
                 'Global and Default are mutually exclusive!'),
         ]
 
-    def default_global_p(self):
+    @staticmethod
+    def default_global_p():
         return True
 
-    def default_default_p(self):
+    @staticmethod
+    def default_default_p():
         return False
 
-    def default_perm_read(self):
+    @staticmethod
+    def default_perm_read():
         return True
 
-    def default_perm_write(self):
+    @staticmethod
+    def default_perm_write():
         return True
 
-    def default_perm_create(self):
+    @staticmethod
+    def default_perm_create():
         return True
 
-    def default_perm_delete(self):
+    @staticmethod
+    def default_perm_delete():
         return True
 
-    def delete(self, ids):
-        res = super(RuleGroup, self).delete(ids)
+    @classmethod
+    def delete(cls, groups):
+        super(RuleGroup, cls).delete(groups)
         # Restart the cache on the domain_get method of ir.rule
-        Pool().get('ir.rule').domain_get.reset()
+        Pool().get('ir.rule')._domain_get_cache.clear()
+
+    @classmethod
+    def create(cls, vals):
+        res = super(RuleGroup, cls).create(vals)
+        # Restart the cache on the domain_get method of ir.rule
+        Pool().get('ir.rule')._domain_get_cache.clear()
         return res
 
-    def create(self, vals):
-        res = super(RuleGroup, self).create(vals)
+    @classmethod
+    def write(cls, groups, vals):
+        super(RuleGroup, cls).write(groups, vals)
         # Restart the cache on the domain_get method of ir.rule
-        Pool().get('ir.rule').domain_get.reset()
-        return res
-
-    def write(self, ids, vals):
-        res = super(RuleGroup, self).write(ids, vals)
-        # Restart the cache on the domain_get method of ir.rule
-        Pool().get('ir.rule').domain_get.reset()
-        return res
-
-RuleGroup()
+        Pool().get('ir.rule')._domain_get_cache.clear()
 
 
 class Rule(ModelSQL, ModelView):
     "Rule"
-    _name = 'ir.rule'
+    __name__ = 'ir.rule'
     _rec_name = 'field'
-    _description = __doc__
     field = fields.Many2One('ir.model.field', 'Field',
         domain=[('model', '=', Eval('_parent_rule_group', {}).get('model'))],
         select=True, required=True)
@@ -96,18 +104,21 @@
     operand = fields.Selection('get_operand', 'Operand', required=True)
     rule_group = fields.Many2One('ir.rule.group', 'Group', select=True,
        required=True, ondelete="CASCADE")
+    _domain_get_cache = Cache('ir_rule.domain_get')
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
 
-        super(Rule, self).init(module_name)
+        super(Rule, cls).__register__(module_name)
 
         # Migration from 2.0: rename operator '<>' into '!='
         cursor.execute('UPDATE "%s" '
             'SET operator = %%s '
-            'WHERE operator = %%s' % self._table, ('!=', '<>'))
+            'WHERE operator = %%s' % cls._table, ('!=', '<>'))
 
-    def _operand_get(self, obj_name='', level=3, recur=None, root_tech='',
+    @classmethod
+    def _operand_get(cls, obj_name='', level=3, recur=None, root_tech='',
             root=''):
         res = {}
         if not obj_name:
@@ -123,33 +134,36 @@
 
             if obj_fields[k]['type'] in ('many2one'):
                 res[root + '/' + obj_fields[k]['string']] = (
-                    '(' + root_tech + '.' + k + '.id '
-                    'if ' + root_tech + ' else None)')
+                    '(%s.%s.id if %s.%s else None)'
+                    % (root_tech, k, root_tech, k))
 
             elif obj_fields[k]['type'] in ('many2many', 'one2many'):
-                res[root + '/' + obj_fields[k]['string']] = \
-                        '[x.id for x in ' + root_tech + '.' + k + ']'
+                res[root + '/' + obj_fields[k]['string']] = (
+                    '[x.id for x in (%s.%s or [])]'
+                    % (root_tech, k))
             else:
                 res[root + '/' + obj_fields[k]['string']] = \
-                        root_tech + '.' + k
+                    root_tech + '.' + k
 
             if (obj_fields[k]['type'] in recur) and (level > 0):
-                res.update(self._operand_get(obj_fields[k]['relation'],
-                    level - 1, recur, root_tech + '.' + k,
-                    root + '/' + obj_fields[k]['string']))
+                res.update(cls._operand_get(obj_fields[k]['relation'],
+                        level - 1, recur,
+                        '(%s.%s if %s else None)' % (root_tech,  k, root_tech),
+                        root + '/' + obj_fields[k]['string']))
 
         return res
 
-    def get_operand(self):
+    @classmethod
+    def get_operand(cls):
         res = []
-        operands = self._operand_get('res.user', level=1, recur=['many2one'],
+        operands = cls._operand_get('res.user', level=1, recur=['many2one'],
                 root_tech='user', root='User')
         for i in operands.keys():
             res.append((i, i))
         return res
 
-    @Cache('ir_rule.domain_get')
-    def domain_get(self, model_name, mode='read'):
+    @classmethod
+    def domain_get(cls, model_name, mode='read'):
         assert mode in ['read', 'write', 'create', 'delete'], \
                 'Invalid domain mode for security'
 
@@ -158,30 +172,35 @@
             if not Transaction().context.get('user'):
                 return '', []
             with Transaction().set_user(Transaction().context['user']):
-                return self.domain_get(model_name, mode=mode)
+                return cls.domain_get(model_name, mode=mode)
+
+        key = (model_name, mode)
+        domain = cls._domain_get_cache.get(key)
+        if domain:
+            return domain
 
         pool = Pool()
-        rule_group_obj = pool.get('ir.rule.group')
-        model_obj = pool.get('ir.model')
-        rule_group_user_obj = pool.get('ir.rule.group-res.user')
-        rule_group_group_obj = pool.get('ir.rule.group-res.group')
-        user_group_obj = pool.get('res.user-res.group')
-        user_obj = pool.get('res.user')
+        RuleGroup = pool.get('ir.rule.group')
+        Model = pool.get('ir.model')
+        RuleGroup_User = pool.get('ir.rule.group-res.user')
+        RuleGroup_Group = pool.get('ir.rule.group-res.group')
+        User_Group = pool.get('res.user-res.group')
+        User = pool.get('res.user')
 
         cursor = Transaction().cursor
-        cursor.execute('SELECT r.id FROM "' + self._table + '" r '
-            'JOIN "' + rule_group_obj._table + '" g '
+        cursor.execute('SELECT r.id FROM "' + cls._table + '" r '
+            'JOIN "' + RuleGroup._table + '" g '
                 "ON (g.id = r.rule_group) "
-            'JOIN "' + model_obj._table + '" m ON (g.model = m.id) '
+            'JOIN "' + Model._table + '" m ON (g.model = m.id) '
             "WHERE m.model = %s "
                 "AND g.perm_" + mode + " "
                 "AND (g.id IN ("
                         'SELECT rule_group '
-                        'FROM "' + rule_group_user_obj._table + '" '
+                        'FROM "' + RuleGroup_User._table + '" '
                         'WHERE "user" = %s '
                         "UNION SELECT rule_group "
-                        'FROM "' + rule_group_group_obj._table + '" g_rel '
-                        'JOIN "' + user_group_obj._table + '" u_rel '
+                        'FROM "' + RuleGroup_Group._table + '" g_rel '
+                        'JOIN "' + User_Group._table + '" u_rel '
                             'ON (g_rel."group" = u_rel."group") '
                         'WHERE u_rel."user" = %s) '
                     "OR default_p "
@@ -189,19 +208,20 @@
                 (model_name, Transaction().user, Transaction().user))
         ids = [x[0] for x in cursor.fetchall()]
         if not ids:
+            cls._domain_get_cache.set(key, ('', []))
             return '', []
         obj = pool.get(model_name)
         clause = {}
         clause_global = {}
-        operand2query = self._operand_get('res.user', level=1,
+        operand2query = cls._operand_get('res.user', level=1,
                 recur=['many2one'], root_tech='user', root='User')
         user_id = Transaction().user
         with Transaction().set_user(0, set_context=True):
-            user = user_obj.browse(user_id)
+            user = User(user_id)
         # Use root user without context to prevent recursion
         with contextlib.nested(Transaction().set_user(0),
                 Transaction().set_context(user=0)):
-            for rule in self.browse(ids):
+            for rule in cls.browse(ids):
                 dom = safe_eval("[('%s', '%s', %s)]" % \
                         (rule.field.name, rule.operator,
                             operand2query[rule.operand]), {
@@ -209,7 +229,7 @@
                                 'time': time,
                                 })
 
-                if rule.rule_group['global_p']:
+                if rule.rule_group.global_p:
                     clause_global.setdefault(rule.rule_group.id, ['OR'])
                     clause_global[rule.rule_group.id].append(dom)
                 else:
@@ -220,17 +240,17 @@
         val = []
 
         # Test if there is no rule_group that have no rule
-        cursor.execute('SELECT g.id FROM "' + rule_group_obj._table + '" g ' \
-                'JOIN "' + model_obj._table + '" m ON (g.model = m.id) ' \
+        cursor.execute('SELECT g.id FROM "' + RuleGroup._table + '" g ' \
+                'JOIN "' + Model._table + '" m ON (g.model = m.id) ' \
             'WHERE m.model = %s ' \
                 'AND (g.id NOT IN (SELECT rule_group ' \
-                        'FROM "' + self._table + '")) ' \
+                        'FROM "' + cls._table + '")) ' \
                 'AND (g.id IN (SELECT rule_group ' \
-                        'FROM "' + rule_group_user_obj._table + '" ' \
+                        'FROM "' + RuleGroup_User._table + '" ' \
                         'WHERE "user" = %s ' \
                         'UNION SELECT rule_group ' \
-                        'FROM "' + rule_group_group_obj._table + '" g_rel ' \
-                            'JOIN "' + user_group_obj._table + '" u_rel ' \
+                        'FROM "' + RuleGroup_Group._table + '" g_rel ' \
+                            'JOIN "' + User_Group._table + '" u_rel ' \
                                 'ON g_rel."group" = u_rel."group" ' \
                         'WHERE u_rel."user" = %s))',
             (model_name, user_id, user_id))
@@ -249,24 +269,24 @@
 
         query, val, _, _ = obj.search_domain(clause, active_test=False)
 
+        cls._domain_get_cache.set(key, (query, val))
         return query, val
 
-    def delete(self, ids):
-        res = super(Rule, self).delete(ids)
+    @classmethod
+    def delete(cls, rules):
+        super(Rule, cls).delete(rules)
         # Restart the cache on the domain_get method of ir.rule
-        self.domain_get.reset()
+        cls._domain_get_cache.clear()
+
+    @classmethod
+    def create(cls, vals):
+        res = super(Rule, cls).create(vals)
+        # Restart the cache on the domain_get method of ir.rule
+        cls._domain_get_cache.clear()
         return res
 
-    def create(self, vals):
-        res = super(Rule, self).create(vals)
-        # Restart the cache on the domain_get method of ir.rule
-        self.domain_get.reset()
-        return res
-
-    def write(self, ids, vals):
-        res = super(Rule, self).write(ids, vals)
+    @classmethod
+    def write(cls, rules, vals):
+        super(Rule, cls).write(rules, vals)
         # Restart the cache on the domain_get method
-        self.domain_get.reset()
-        return res
-
-Rule()
+        cls._domain_get_cache.clear()
